﻿@{
    ViewData["Title"] = "home Page";
}

@section head{

    <link rel="stylesheet" href="https://js.arcgis.com/4.17/esri/themes/light/main.css">
    <script src="https://js.arcgis.com/4.17/"></script>

    <script>
        require([
            "esri/Map",
            "esri/views/MapView",
            "esri/Graphic",
            "esri/layers/GraphicsLayer",
            "esri/layers/FeatureLayer",
            "esri/symbols/PictureMarkerSymbol"], function (Map, MapView, Graphic, GraphicsLayer, FeatureLayer, PictureMarkerSymbol) {

                var graphicsLayer = new GraphicsLayer();

                var map = new Map({
                    basemap: "topo-vector",
                    layers: [ graphicsLayer ]
                });

                var view = new MapView({
                    container: "map",
                    map: map,
                    center: [-3.805, 40.027], // longitude, latitude
                    zoom: 7,
                    popup: {
                        dockEnabled: true,
                        dockOptions: {
                            position: "top-right",
                            breakpoint: false
                        }
                    }
                });

                view.on("pointer-move", function (evt) {
                    showCoordinates(view.toMap({ x: evt.x, y: evt.y }));
                });

                view.on("hold", function (evt) {
                    var point = view.toMap({ x: evt.x, y: evt.y })

                    document.getElementById("photo_position").value = String(point.latitude) + ";" + String(point.longitude);

                    @(ViewBag.UserLogin ? "openFotos();" : "openLogin();" )
                });


                function showCoordinates(pt) {

                    graphicsLayer.removeAll();

                    var symbol = {
                        type: "picture-marker",  // autocasts as new PictureMarkerSymbol()
                        url: "/img/motocicleta.png",
                        width: "24px",
                        height: "24px",
                        yoffset: 12
                    };

                    var pointGraphic = new Graphic({
                        geometry: pt,
                        symbol: symbol
                    });

                    graphicsLayer.add(pointGraphic);
                }

                $(document).ready(function () {

                    $.get("/Fotos/GetFotos", function (data) {

                        var graphicsArray = new Array();

                        $(data).each(function (index, element) {

                            var getUrl = window.location;
                            var baseUrl = getUrl.protocol + "//" + getUrl.host;

                            var point = {
                                type: "point",
                                latitude: element.latitude,
                                longitude: element.longitude
                            };

                            var symbol = {
                                type: "picture-marker",  // autocasts as new PictureMarkerSymbol()
                                url: "/img/photo-frame.png",
                                width: "24px",
                                height: "24px"
                            };

                            var pointGraphic = new Graphic({
                                geometry: point,
                                symbol: symbol,
                                attributes: {
                                    url: baseUrl + element.foto,
                                    OBJECTID: element.id,
                                    title: element.titulo,
                                    email: element.userEmail,
                                    date: element.visibleDate
                                }
                            });

                            console.log(element.foto);

                            graphicsArray.push(pointGraphic);
                        });

                        view.map.add(createLayer(graphicsArray));

                    });

                });

                function createLayer(graphics) {
                    return new FeatureLayer({
                        source: graphics,
                        objectIdField: "OBJECTID",
                        fields: [
                            {
                                name: "OBJECTID",
                                type: "oid"
                            },
                            {
                                name: "url",
                                type: "string"
                            },
                            {
                                name: "title",
                                type: "string"
                            },
                            {
                                name: "date",
                                type: "string"
                            },
                            {
                                name: "email",
                                type: "string"
                            }
                        ],
                        popupTemplate: {
                            title: "{title}",
                            content: "<span class='cell'>Fecha: {date}</span><span class='cell'>Author: {email}</span><span class='cell'><img src='{url}' /></span>"
                        },
                        renderer: {
                            type: "simple",
                            symbol: {
                                type: "picture-marker",
                                url: "/img/photo-frame.png",
                                width: "24px",
                                height: "24px"
                            }
                        }
                    });
                }

            });

        function openFotos() {
            document.getElementById("anade").style.display = "block";
        }

        function closeFotos() {
            document.getElementById("anade").style.display = "none";
        }

    </script>

}

<div id="map"></div>

<div class="actions">
    <div>
        <img src="~/img/photo-frame.png" id="route" />
        <img src="~/img/plus.png" id="plus" />
        <h3>Añade tu foto<br /><span class="little_italic">Pulsación larga para seleccionar la ubicación de tu foto</span></h3>
    </div>
</div>

<partial name="_PopUpAnadetufoto.cshtml" />